% !TEX root = main.tex

%----------------------------
%   Fonts and characters
%----------------------------

% Support for special characters
\usepackage[utf8]{inputenc}    % Specify input encoding
\usepackage[T1]{fontenc}       % Specify font encoding

%% Pour police écriture (main font)
% Set main fonts : police d'écriture mise en place via \usepackage{nom_police}
% Fonts catalogue: https://tug.org/FontCatalogue/
%% Différents exs : http://www.cuk.ch/articles/4237/
%% Origin : 
%\usepackage{mathpazo}          % Use the Mathpazo (Palatino) font by default
\usepackage{beramono}          % Override the monospace/typewriter font.

%\usepackage{mathpazo}          % Use the Mathpazo (Palatino) font by default
%\usepackage{txfonts}          % Override the monospace/typewriter font. Equations font will keep Palatino.
%\usepackage{beramono}          % Override the monospace/typewriter font.
%\usepackage{}

% ZHAW title font
% Try to load Helvetica Rounded Bold, and OpenType font.
% Loading OTF or system fonts is possible with XeLaTeX.
% If the document is compiled using pdfLaTeX, resort 
\usepackage{ifxetex}
\ifxetex
    \usepackage{fontspec}
    \newfontfamily\zhawtitlefont{Helvetica Rounded Bold}
\else
    \newcommand{\zhawtitlefont}{\scshape}
\fi

%\usepackage[scaled]{helvet}

%----------------------------
%   Environments
%----------------------------
%% Pour forcer le placement des figures à certains endroits : https://tex.stackexchange.com/questions/8625/force-figure-placement-in-text
\usepackage{float}

\usepackage{caption}           % Customized caption
\usepackage{subcaption}        % Subfigure captions
\usepackage{makecell}          % Per-cell formatting in tables (\makecell)
\usepackage{pdfpages}          % Required to include PDF files/graphics (\includepdf)

\usepackage{todonotes}         % Introduces the command \todo
\setlength{\marginparwidth}{2.5cm} % Adjust this if the todo notes are out of margins

\usepackage{xcolor}

\definecolor{binria}{RGB}{56, 66, 87} %% couleurs inria - bleu ==> {0.21875, 0.2578, 0.3398}
\definecolor{rinria}{RGB}{230, 51, 18} %% couelurs inria - rouge ==> {0.8984, 0.1992, 0.0703}


% Create boxes as follows:
% \begin{colorbox}{red}{2}
\usepackage{tcolorbox}
\newtcolorbox{textbox}[2]{
    arc=3pt,
    boxrule=#2pt,
    colback=#1!25!white,
    width=\textwidth,
    halign=left,
    valign=center,
    colframe=#1!75!black
}
%% From https://tex.stackexchange.com/questions/371440/optional-arguments-in-the-newtcolorbox-macro
%% Boîtes pour les questions
\newtcolorbox{quest}[1]{
    colback=white!25!white,
    % colframe=rinria!75!black,
    colframe=rinria,    
    fonttitle=\bfseries,
    title=#1,
    arc=3pt,
    width=\textwidth,
    halign=left,
    valign=center
    % ,anchor=east,rectangle
  %   ,overlay={%
  %     \node[anchor=north,text width=\tcb@width-4\pgflinewidth-6mm,fill=olive,inner xsep=3mm]
  %       (a) at ([yshift=2mm]frame.south);
  %     \draw[red,line width=1pt] (a.north west) -- (a.south west) -| (a.north east);
  % }
}

%% Boîtes pour les questions
\newtcolorbox{hyp}[1]{
    colback=white!25!white,
    % colframe=rinria!75!black,
    colframe=binria,    
    fonttitle=\bfseries,
    title=#1,
    arc=3pt,
    width=\textwidth,
    halign=left,
    valign=center
    % ,anchor=east,rectangle
  %   ,overlay={%
  %     \node[anchor=north,text width=\tcb@width-4\pgflinewidth-6mm,fill=olive,inner xsep=3mm]
  %       (a) at ([yshift=2mm]frame.south);
  %     \draw[red,line width=1pt] (a.north west) -- (a.south west) -| (a.north east);
  % }
}

%% options [most]/[skins] incompatible avec reste, tout bug :(
% \newtcolorbox{quest}[1]{colback=red!5!white,
% colframe=red!75!black,fonttitle=\bfseries,
% colbacktitle=red!85!black,enhanced,
% attach boxed title to top center={yshift=-2mm},
% title=#1}

% https://tex.stackexchange.com/questions/214716/how-to-place-a-title-in-the-tcolorbox-to-the-bottom-left-right-of-the-box
% \newtcolorbox{quest}[1][]{
% boxsep=0pt,bottom=3mm,left=3mm,right=3mm,top=3mm,boxrule=1pt,colframe=red,arc=3pt,title=#1,
% overlay={%
%       \node[anchor=north,text width=\tcb@width-4\pgflinewidth-6mm,fill=olive,inner xsep=3mm]
%         (a) at ([yshift=2mm]frame.south);
%       \draw[red,line width=1pt] (a.north west) -- (a.south west) -| (a.north east);
%   }
% }

%----------------------------
%   Colors
%----------------------------

% Set up colors
%\usepackage{xcolor}
% ZHAW Blue: Pantone 2945 U / R0 G100 B166

\definecolor{zhawblue}{rgb}{0.00, 0.39, 0.65}

% Colors related to code listings
\definecolor{codegreen}{rgb}{0,0.6,0}
\definecolor{codegray}{rgb}{0.5,0.5,0.5}
\definecolor{codepurple}{rgb}{0.58,0,0.82}
\definecolor{codebackground}{rgb}{0.93,0.94,0.95}

%----------------------------
%   Code listings
%----------------------------

% Setup code listings
\usepackage{listings}
\lstdefinestyle{mystyle}{
    backgroundcolor=\color{codebackground},   
    commentstyle=\color{codegreen},
    keywordstyle=\color{magenta},
    numberstyle=\tiny\color{codegray},
    stringstyle=\color{codepurple},
    basicstyle=\ttfamily\footnotesize,
    breakatwhitespace=false,
    breaklines=true,
%    captionpos=b,
    keepspaces=true,
    numbers=left,
    numbersep=5pt,
    showspaces=false,
    showstringspaces=false,
    showtabs=false,
    tabsize=4
}
\lstset{style=mystyle}

% minted is an alternative code listing package. (See chapter 2)
% For it to run successfully, ensure the following:
% - the Python package Pygments. Install with the following command:
%       python -m pip install Pygments
% - pdflatex (or xelatex) is executed with the flag --shell-escape
%   If you are using a TEX editor, you can modify the typesetting 
%   command somewhere in the settings.
%\usepackage[outputdir=build]{minted}
%\usemintedstyle{xcode}
% For fancier coloring schemes, see here:
% https://tex.stackexchange.com/questions/585582
% One could also create an own style in Pygments
% https://pygments.org/docs/styles/#creating-own-styles

%----------------------------
%   References
%----------------------------

% Set up references
%% For different sorting options, please check : https://tex.stackexchange.com/questions/51434/biblatex-citation-order
\usepackage[
    backref=true,
    backend=biber,             % Use biber backend (an external tool)
    %sorting=none,              % none : Enumerates the reference in order of their appearance
    sorting=nyt,                % nyt : enumerates by name, year, title
    hyperref=true,
    mincitenames=1,
    maxcitenames=1,             %% max number of names in references
    maxbibnames=50,                %% max number of names in bibliography. Set to huge value to avoid "et al". 
    uniquelist=false,
    eprint=false,doi=false,isbn=false,url=false, % https://tex.stackexchange.com/a/23118
    % style=numeric-comp         % Choose here your preferred citation style
    % style=authoryear-comp        % breaks repeated cites
    style=authoryear        % Choose here your preferred citation style
]{biblatex}

\addbibresource{biblio.bib}  % The filename of the bibliography

%% Settings for bilbiography

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% backref for cited on pages...
% https://tex.stackexchange.com/a/36308
\DefineBibliographyStrings{english}{%
  backrefpage  = {cited on page}, % originally "cited on page"
  backrefpages = {cited on pages},% originally "cited on pages"
}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% linebreak before backref
% https://tex.stackexchange.com/a/76136
\setlength\bibitemsep{1.7\itemsep}
\renewcommand*{\finentrypunct}{}
\renewbibmacro*{pageref}{%
  \addperiod% NEW
  \iflistundef{pageref} {}
    {
    \begin{flushright}
    % \linebreak
    \footnotesize\printtext[parens]{% NEW
       \ifnumgreater{\value{pageref}}{1}
         {\bibstring{backrefpages}\ppspace}
     {\bibstring{backrefpage}\ppspace}%
       \printlist[pageref][-\value{listtotal}]{pageref}}
    \end{flushright}
    }}% NEW
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% https://tex.stackexchange.com/questions/1687/hyperlink-name-with-biblatex-authoryear
%%%%%%%%%%%%%%%%%%%%%%%%%
% duplicated works but no hyper
% \makeatletter
% \newrobustcmd*{\parentexttrack}[1]{%
%   \begingroup
%   \blx@blxinit
%   \blx@setsfcodes
%   \blx@bibopenparen#1\blx@bibcloseparen
%   \endgroup}
% \AtEveryCite{%
%   \let\parentext=\parentexttrack%
%   \let\bibopenparen=\bibopenbracket%
%   \let\bibcloseparen=\bibclosebracket}
% \makeatother
%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%
% duplicated NOT work (with authoryear-comp) but hyper yes
\DeclareCiteCommand{\parencite}
  {\usebibmacro{prenote}}
  {\usebibmacro{citeindex}%
   \printtext[bibhyperref]{[\usebibmacro{cite}]}}
  %                        ^                  ^
  {\multicitedelim}
  {\usebibmacro{postnote}}
% \makeatletter
% \newrobustcmd*{\parentexttrack}[1]{%
%   \begingroup
%   \blx@blxinit
%   \blx@setsfcodes
%   \blx@bibopenparen#1\blx@bibcloseparen
%   \endgroup}

% \AtEveryCite{%
%   \let\parentext=\parentexttrack%
%   \let\bibopenparen=\bibopenbracket%
%   \let\bibcloseparen=\bibclosebracket}
% \makeatother
%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% https://tex.stackexchange.com/a/318312
\usepackage{letltxmacro}\LetLtxMacro{\cite}{\parencite} % remove / comment to use numeric-comp biblatex style
\renewcommand*{\nameyeardelim}{\addcomma\space}

\usepackage[autostyle=true]{csquotes}
                               % Required to generate language-dependent quotes 
                               % in the bibliography

%----------------------------------------------------------------------------------------
%   MARGIN SETTINGS
%----------------------------------------------------------------------------------------

\geometry{
    paper=a4paper,      % Change to letterpaper for US letter
    inner=2.5cm,        % Inner margin
    outer=3.8cm,        % Outer margin
    top=1.5cm,          % Top margin
    bottom=1.5cm,       % Bottom margin
    bindingoffset=.5cm, % Binding offset
    %showframe,         % Show the type block of the page
}
\setlength{\parskip}{1em}
\usepackage{enumitem}          % Layout control for list environments (e.g, itemize)
%\setlist{noitemsep}           % Suppress extra spaces between items
%\setlist{nosep}               % Suppress spaces before/after list environments


